/*LIBRERIA PER IL PROBLEMA LETTORE SCRITTORE CON L'USO DEL MONITOR*/

#include "libmon.c" /*include la libreria di gestione del monitor*/

#define OK_LETTURA  0
#define OK_SCRITTURA 1

/*prototipi delle funzioni*/
void inizializza();       /*inizializza il monitor*/
void termina();
void inizio_lettura();
void fine_lettura();
void inizio_scrittura();
void fine_scrittura();

/*variabili del monitor*/
monitor *ls;
int num_lett,occupato;

/*procedura per l'inizializzazione delle variabili e del monitor*/
void inizializza()
{
	num_lett=0;
	occupato=0;
	ls=implem_monitor(2);
}

/*procedura di terminazione dell'utilizzo del monitor*/
void termina()
{
	remove_monitor(ls);
}

void inizio_lettura()
{
	if (occupato || queuecond(*ls,OK_SCRITTURA)>0)
		waitcond(ls,OK_LETTURA);
	num_lett++;
	signalcond(ls,OK_LETTURA);
}

void fine_lettura()
{
	num_lett--;
	if (num_lett==0)
		signalcond(ls,OK_SCRITTURA);
}


void inizio_scrittura()
{
	if (occupato || num_lett!=0)
		waitcond(ls,OK_SCRITTURA);
	occupato=1;
}

void fine_scrittura()
{
	occupato=0;
	if (queuecond(*ls,OK_LETTURA)>0)
		signalcond(ls,OK_LETTURA);
	else
		signalcond(ls,OK_SCRITTURA);
}





